
#property copyright "*"
#property link      "*"

#property indicator_chart_window
//---- input parameters
extern int       iHalfPeriod=14;
extern bool      ShowTrendLines=false;
extern bool      ShowSupResLines=false;
extern bool      ShowFiboLines=false;
extern bool      ShowFiboExpansion=false;
extern bool      ShowFiboFan=false;
extern int       FiboFanType=1;
extern bool      ShowFiboArc=false;
extern int       FiboArcType=1;
extern bool      ShowFiboTime=false;
extern int       FiboTimeType=1;
extern int       Count=5;  
extern int       Shift=0;  

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];


double u_v[];
int    u_t[];
double l_v[];
int    l_t[];
double _v[10];
int    _t[10];
string _tp[10];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   ArrayResize(u_v,Count+Shift+10);
   ArrayResize(u_t,Count+Shift+10);
   ArrayResize(l_v,Count+Shift+10);
   ArrayResize(l_t,Count+Shift+10);  
   ArrayResize(_t,2*Count+Shift+20);
   ArrayResize(_v,2*Count+Shift+20);
   ArrayResize(_tp,2*Count+Shift+20);     
  
//---- indicators
   IndicatorBuffers(2);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   

     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=ObjectsTotal();i>=0;i--){
      if(StringFind(ObjectName(i),"LN_NDaysMax_",0)==0){
         ObjectDelete(ObjectName(i));
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit=Bars-IndicatorCounted();
   
      for(int i=limit;i>=0;i--){
         ExtMapBuffer1[i]=0;
         ExtMapBuffer2[i]=0;         
         int hb=Highest(NULL,0,MODE_HIGH,iHalfPeriod*2+1,i+1);
         int lb=Lowest(NULL,0,MODE_LOW,iHalfPeriod*2+1,i+1); 
         
            if(hb==i+iHalfPeriod+2){
               ExtMapBuffer1[hb]=High[hb];
                  for(int j=hb+1;j<Bars;j++){
                     if(ExtMapBuffer1[j]!=0){
                              if(u_t[0]!=Time[hb]){
                                 for(int g=ArraySize(u_v)-1;g>0;g--){
                                    u_v[g]=u_v[g-1];
                                    u_t[g]=u_t[g-1];                                    
                                 }
                                 u_v[0]=High[hb];
                                 u_t[0]=Time[hb];
                              }    
                              if(_t[0]!=Time[hb]){
                                 if(_tp[0]=="u"){
                                    if(_v[0]<High[hb]){
                                       _v[0]=High[hb];
                                       _t[0]=Time[hb];                                    
                                    }
                                 }
                                 else{
                                       for(g=ArraySize(_v)-1;g>0;g--){
                                          _v[g]=_v[g-1];
                                          _t[g]=_t[g-1];                                    
                                          _tp[g]=_tp[g-1]; 
                                       }
                                    _v[0]=High[hb];
                                    _t[0]=Time[hb];
                                    _tp[0]="u";    
                                 }
                              }                                                                                                  
                        break;
                     }
                  }
            }
            if(lb==i+iHalfPeriod+2){
               ExtMapBuffer2[lb]=Low[lb];
                  for(j=lb+1;j<Bars;j++){
                     if(ExtMapBuffer2[j]!=0){
   
                              if(l_t[0]!=Time[lb]){
                                 for(g=ArraySize(l_v)-1;g>0;g--){
                                    l_v[g]=l_v[g-1];
                                    l_t[g]=l_t[g-1]; 
                                 }
                                 l_v[0]=Low[lb];
                                 l_t[0]=Time[lb];
                              }  
                              if(_t[0]!=Time[lb]){
                                 if(_tp[0]=="l"){
                                    if(_v[0]>Low[lb]){
                                       _v[0]=Low[lb];
                                       _t[0]=Time[lb];                                    
                                    }
                                 }
                                 else{
                                       for(g=ArraySize(_v)-1;g>0;g--){
                                          _v[g]=_v[g-1];
                                          _t[g]=_t[g-1]; 
                                          _tp[g]=_tp[g-1];                                                                        
                                       }
                                    _v[0]=Low[lb];
                                    _t[0]=Time[lb];
                                    _tp[0]="l";                                 
                                 }
                              }                                                                                                  
                        break;
                     }
                  }               
            }            
      }
      
      if(ShowTrendLines){
         for(i=Shift;i<Shift+Count;i++){
            string on="LN_NDaysMax_TL_Sup_"+i;
            if(ObjectFind(on)!=0){
               ObjectCreate(on,OBJ_TREND,0,l_t[i+1],l_v[i+1],l_t[i],l_v[i]);
            }
            ObjectSet(on,OBJPROP_TIME1,l_t[i+1]);
            ObjectSet(on,OBJPROP_TIME2,l_t[i]);
            ObjectSet(on,OBJPROP_PRICE1,l_v[i+1]);
            ObjectSet(on,OBJPROP_PRICE2,l_v[i]);
            ObjectSet(on,OBJPROP_RAY,true);
            ObjectSet(on,OBJPROP_COLOR,Red);
            
            on="LN_NDaysMax_TL_Res_"+i;
            if(ObjectFind(on)!=0){
               ObjectCreate(on,OBJ_TREND,0,u_t[i+1],u_v[i+1],u_t[i],u_v[i]);
            }
            ObjectSet(on,OBJPROP_TIME1,u_t[i+1]);
            ObjectSet(on,OBJPROP_TIME2,u_t[i]);
            ObjectSet(on,OBJPROP_PRICE1,u_v[i+1]);
            ObjectSet(on,OBJPROP_PRICE2,u_v[i]);
            ObjectSet(on,OBJPROP_RAY,true);
            ObjectSet(on,OBJPROP_COLOR,DodgerBlue);            
            
         }
      }
      
      if(ShowSupResLines){
         for(i=Shift;i<Shift+Count;i++){
            on="LN_NDaysMax_Sup_"+i;
            if(ObjectFind(on)!=0){
               ObjectCreate(on,OBJ_TREND,0,l_t[i],l_v[i],l_t[i]+Period()*60,l_v[i]);
            }
            ObjectSet(on,OBJPROP_TIME1,l_t[i]);
            ObjectSet(on,OBJPROP_TIME2,l_t[i]+Period()*60);
            ObjectSet(on,OBJPROP_PRICE1,l_v[i]);
            ObjectSet(on,OBJPROP_PRICE2,l_v[i]);
            ObjectSet(on,OBJPROP_RAY,true);
            ObjectSet(on,OBJPROP_COLOR,Red);
            
            on="LN_NDaysMax_Res_"+i;
            if(ObjectFind(on)!=0){
               ObjectCreate(on,OBJ_TREND,0,u_t[i],u_v[i],u_t[i]+Period()*60,u_v[i]);
            }
            ObjectSet(on,OBJPROP_TIME1,u_t[i]);
            ObjectSet(on,OBJPROP_TIME2,u_t[i]+Period()*60);
            ObjectSet(on,OBJPROP_PRICE1,u_v[i]);
            ObjectSet(on,OBJPROP_PRICE2,u_v[i]);
            ObjectSet(on,OBJPROP_RAY,true);
            ObjectSet(on,OBJPROP_COLOR,DodgerBlue);            
            
         }
      }
      
      if(ShowFiboLines){
         double v1,v2;datetime t1,t2;
         int ind;
         string ft;
         bool f;
         int fli=0;
         
         ind=Shift;
         
         for(fli=1;fli<=Count;fli++){
         v1=_v[ind];
         v2=_v[ind];         
         t1=_t[ind];
         ft=_tp[ind];
         
            f=false;
            for(i=ind+1;i<2*Count+Shift+20;i++){
               if(_tp[i]==ft){
                  if(!f){
                     if(ft=="u"){
                        if(v1<_v[i]){
                           v1=_v[i];
                           t1=_t[i]; 
                           v2=_v[i];   
                                                  
                        }
                     }
                     if(ft=="l"){
                        if(v1>_v[i]){
                           v1=_v[i];
                           t1=_t[i];   
                           v2=_v[i];
                                                  
                        }                     
                     }                     
                  }
                  if(f){
                     break;
                  }                
               }
               if(_tp[i]!=ft){
                     if(ft=="u"){
                        if(v2>_v[i]){
                           v2=_v[i];
                           t2=_t[i]; 
                           ind=i;
                           f=true;
                           
                        }
                     }
                     if(ft=="l"){
                        if(v2<_v[i]){
                           v2=_v[i];
                           t2=_t[i];  
                           ind=i; 
                           f=true;
                           
                        }                     
                     }                                
               }               
            }
            if(f){
               on="LN_NDaysMax_FiboRetr_"+fli;
               if(ObjectFind(on)!=0){
                  ObjectCreate(on,OBJ_FIBO,0,t1,v1,t2,v2);
               }
               ObjectSet(on,OBJPROP_TIME1,t1);
               ObjectSet(on,OBJPROP_TIME2,t2);
               ObjectSet(on,OBJPROP_PRICE1,v1);
               ObjectSet(on,OBJPROP_PRICE2,v2);               
            }
         }   
      }
      
      if(ShowFiboExpansion){
         for(i=Shift;i<Count+Shift-2;i++){
            on="LN_NDaysMax_FiboExp_"+i;
               if(ObjectFind(on)!=0){
                  ObjectCreate(on,OBJ_EXPANSION,0,_t[i+2],_v[i+2],_t[i+1],_v[i+1],_t[i],_v[i]);
               }
               ObjectSet(on,OBJPROP_TIME1,_t[i+2]);
               ObjectSet(on,OBJPROP_TIME2,_t[i+1]);
               ObjectSet(on,OBJPROP_TIME3,_t[i]);               
               ObjectSet(on,OBJPROP_PRICE1,_v[i+2]);
               ObjectSet(on,OBJPROP_PRICE2,_v[i+1]);  
               ObjectSet(on,OBJPROP_PRICE3,_v[i]);              
         }
      }  
      if(ShowFiboFan){
         for(i=Shift;i<Count+Shift;i++){
            on="LN_NDaysMax_FiboFan_"+i;
               if(ObjectFind(on)!=0){
                  ObjectCreate(on,OBJ_FIBOFAN,0,_t[i+FiboFanType],_v[i+FiboFanType],_t[i],_v[i]);
               }
               ObjectSet(on,OBJPROP_TIME1,_t[i+FiboFanType]);
               ObjectSet(on,OBJPROP_TIME2,_t[i]);
               ObjectSet(on,OBJPROP_PRICE1,_v[i+FiboFanType]);
               ObjectSet(on,OBJPROP_PRICE2,_v[i]);  
         }         
      }
      if(ShowFiboArc){
         for(i=Shift;i<Count+Shift;i++){
            on="LN_NDaysMax_FiboArc_"+i;
               if(ObjectFind(on)!=0){
                  ObjectCreate(on,OBJ_FIBOARC,0,_t[i+FiboArcType],_v[i+FiboArcType],_t[i],_v[i]);
               }
               ObjectSet(on,OBJPROP_TIME1,_t[i+FiboArcType]);
               ObjectSet(on,OBJPROP_TIME2,_t[i]);
               ObjectSet(on,OBJPROP_PRICE1,_v[i+FiboArcType]);
               ObjectSet(on,OBJPROP_PRICE2,_v[i]); 
               ObjectSet(on,OBJPROP_ELLIPSE,true); 
         }        
      }  
      if(ShowFiboTime){
         for(i=Shift;i<Count+Shift;i++){
            on="LN_NDaysMax_FiboTime_"+i;
               if(ObjectFind(on)!=0){
                  ObjectCreate(on,OBJ_FIBOTIMES,0,_t[i+FiboTimeType],_v[i+FiboTimeType],_t[i],_v[i]);
               }
               ObjectSet(on,OBJPROP_TIME1,_t[i+FiboTimeType]);
               ObjectSet(on,OBJPROP_TIME2,_t[i]);
               ObjectSet(on,OBJPROP_PRICE1,_v[i+FiboTimeType]);
               ObjectSet(on,OBJPROP_PRICE2,_v[i]); 
               ObjectSet(on,OBJPROP_ELLIPSE,true); 
         }        
      }        
   return(0);
  }
//+------------------------------------------------------------------+